//+------------------------------------------------------------------+
//|                                                 BuySellArrow.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   3
//--- plot Up
#property indicator_label1  "Up"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrLime
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Dn
#property indicator_label2  "Dn"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot UpDn
#property indicator_label3  "UpDn"
#property indicator_type3   DRAW_ARROW
#property indicator_color3  clrBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  2
//--- indicator buffers
double         UpBuffer[];
double         DnBuffer[];
double         UpDnBuffer[];
int handle=0;
int i;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,UpDnBuffer,INDICATOR_DATA);
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   PlotIndexSetInteger(0,PLOT_ARROW,233);
   PlotIndexSetInteger(1,PLOT_ARROW,234);
   PlotIndexSetInteger(2,PLOT_ARROW,108);
   
   ArraySetAsSeries(UpBuffer,true);
   ArraySetAsSeries(DnBuffer,true);
   ArraySetAsSeries(UpDnBuffer,true);
   
   handle=iATR(NULL,0,14);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int limit;
   if(prev_calculated==0 || prev_calculated<0 || prev_calculated>rates_total)
      limit=rates_total-10;
   else
      limit=rates_total-prev_calculated-1;
      
      ArraySetAsSeries(close,true);
      ArraySetAsSeries(open,true);
      ArraySetAsSeries(high,true);
      ArraySetAsSeries(low,true);
      
      for(i=limit;i>=0;i--)
     {
     double atr[];
     CopyBuffer(handle,0,i+1,1,atr);
     
     bool b=signalOpenBuy();
     bool s=signalOpenSell();
     
     if(b && !s)
     UpBuffer[i+1]=low[i]-atr[0];
     
     if(s && !b)
     DnBuffer[i+1]=high[i]+atr[0];
     
     if(b && s)
     UpDnBuffer[i+1]=low[i]-atr[0];
     
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
bool signalOpenBuy()
{

  bool cond1 = High(1)> High(2);
  bool cond2 = High(2)> High(3);
           
  
  if(cond1 && cond2)return true;                                 
					       
  return false;
}

//+------------------------------------------------------------------+
bool signalOpenSell()
{
 

  bool cond1 = High(1)< High(2);
  bool cond2 = High(2)< High(3);
  bool cond3 = Low(1)> Low(2);
  
 
  if(cond1 && cond2 && cond3) 
    return true;
  
  return false;
}

//+------------------------------------------------------------------+
double Close(int j){
double buff[1];
CopyClose(NULL,0,j+i,1,buff);
return buff[0];
}
//+------------------------------------------------------------------+
double High(int j){
double buff[1];
CopyHigh(NULL,0,j+i,1,buff);
return buff[0];
}
//+------------------------------------------------------------------+
double Open(int j){
double buff[1];
CopyOpen(NULL,0,j+i,1,buff);
return buff[0];
}
//+------------------------------------------------------------------+
double Low(int j){
double buff[1];
CopyLow(NULL,0,j+i,1,buff);
return buff[0];
}
//+------------------------------------------------------------------+
double HS(int j){
double res=0;

double c=Close(j);
double o=Open(j);
double h=High(j);

if(c>o)res=(h-c)/_Point;
else res=(h-o)/_Point;

return res;}
//+------------------------------------------------------------------+
double LS(int j){
double res=0;

double c=Close(j);
double o=Open(j);
double l=Low(j);

if(c<o)res=(c-l)/_Point;
else res=(o-l)/_Point;

return res;}
//+------------------------------------------------------------------+
double Body(int j){
double res=0;

double c=Close(j);
double o=Open(j);

res=MathAbs(c-o)/_Point;

return res;}
//+------------------------------------------------------------------+
